<?php
namespace AkTest\Events;

use Ak\Events\ConfigProvider;
use Ak\Test\AbstractTestCase;
use Laminas\EventManager\EventManager;
use Laminas\EventManager\EventManagerInterface;
use Psr\Container\ContainerExceptionInterface;
use Psr\Container\NotFoundExceptionInterface;

/**
 * Class EventManagerTest
 *
 * @package AkTest\Events
 * @author Danijel Fabijan <hipnaba@gmail.com>
 * @link https://bitbucket.org/autokreso/events
 */
final class EventManagerTest extends AbstractTestCase
{
    protected array $providers = [
        ConfigProvider::class,
    ];

    public function testIsRegistered()
    {
        $container = $this->getContainer();

        $this->assertContainerHasService($container, [
            'EventManager',
            EventManagerInterface::class,
            EventManager::class,
        ], EventManagerInterface::class, false);
    }

    /**
     * @return void
     * @throws ContainerExceptionInterface
     * @throws NotFoundExceptionInterface
     */
    public function testSharedEventManagerIsInjected()
    {
        $container = $this->getContainer();
        /** @var EventManager $events */
        $events = $container->get('EventManager');

        $this->assertSame($container->get('SharedEventManager'), $events->getSharedManager());
    }
}
